﻿using Battleship;
using Battleship.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Battleship.DrawningObjects
{
    public class DrawningBattleship : DrawningShip
    {
        public DrawningBattleship(int speed, double weight, Color bodyColor, Color
        additionalColor, bool tower, bool section, int width, int height) 
        : base(speed, weight, bodyColor, width, height, 175, 80)
        {
            if(EntityShip != null)
            {
                EntityShip = new EntityBattleship(speed, weight, bodyColor, additionalColor, tower, section);
            }
        }
        public override void DrawTransport(Graphics g)
        {
            if (EntityShip is not EntityBattleship battleShip)
            {
                return;
            }
            Pen pen = new(Color.Black, 2);
            Brush additionalBrush = new
            SolidBrush(battleShip.AdditionalColor);
            base.DrawTransport(g);

            //орудийная башня
            if (battleShip.Tower)
            {
                Brush baseBrush = new SolidBrush(Color.White);
                g.FillRectangle(baseBrush, _startPosX + 108, _startPosY + 28, 15, 15);
                g.DrawRectangle(pen, _startPosX + 108, _startPosY + 28, 15, 15);
                Brush gunBrush = new SolidBrush(Color.Black);
                g.FillRectangle(gunBrush, _startPosX + 123, _startPosY + 32, 47, 6);
                g.DrawRectangle(pen, _startPosX + 123, _startPosY + 32, 55, 6);
            }
            //отсеки под ракеты
            if (battleShip.Section)
            {
                Brush sectionBrush = new
                SolidBrush(Color.Gray);
                g.FillRectangle(sectionBrush, _startPosX + 20, _startPosY + 70, 40, 10);
                g.DrawRectangle(pen, _startPosX + 20, _startPosY + 70, 40, 10);
                g.FillRectangle(sectionBrush, _startPosX + 75, _startPosY + 70, 40, 10);
                g.DrawRectangle(pen, _startPosX + 75, _startPosY + 70, 40, 10);
            }
        }
    }
}
